#include "stdio.h"
#include "libpq-fe.h"
#include "sys/select.h"
#include "stdbool.h"
#define TRUE true
#define FALSE false

bool is_result_ready( PGconn * connection );

int main()
{
  int i;
  PGconn *c = PQconnectdb("");
  PQsendQuery(c, "select pg_sleep(1)");
  i = is_result_ready(c);

  printf("i=%d\n", i);
//  sleep(1);
  i = is_result_ready(c);
  printf("i=%d\n", i);
}

bool is_result_ready( PGconn * connection )
{
   int                 my_socket;
   struct timeval      timer;
   fd_set              read_mask;

   if( PQisBusy( connection ) == FALSE )
       return( TRUE );

   my_socket = PQsocket( connection );

   timer.tv_sec  = (time_t)1;
   timer.tv_usec = 0;

   FD_ZERO( &read_mask );
   FD_SET( my_socket, &read_mask );

   if( select( my_socket + 1, &read_mask, NULL, NULL, &timer ) == 0 )
   {
       printf("select returned zero\n");
       return( FALSE );
   }
   else if( FD_ISSET( my_socket, &read_mask ))
   {
       if (PQconsumeInput( connection ))
       {
           if( PQisBusy( connection ))
           {
               printf("busy!\n");
               return( FALSE );
           }
           else
           {
               printf("not busy!\n");
               return( TRUE );
           }
       }
       else
       {
           printf("ERROR with PQconsumeInput(): %s\n",
PQerrorMessage(connection));
           return ( FALSE );
       }
   }
   else
   {
       printf("???\n");
       return( FALSE );
   }
}
